$(() => {
const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks';
$('#tree-list').dxTreeList({
dataSource: DevExpress.data.AspNet.createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
insertUrl: `${url}/InsertTask`,
updateUrl: `${url}/UpdateTask`,
deleteUrl: `${url}/DeleteTask`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
}),
remoteOperations: {
filtering: true,
sorting: true,
grouping: true,
},
parentIdExpr: 'Task_Parent_ID',
hasItemsExpr: 'Has_Items',
expandedRowKeys: [1, 2],
searchPanel: {
visible: true,
},
headerFilter: {
visible: true,
},
editing: {
mode: 'row',
allowAdding: true,
allowUpdating: true,
allowDeleting: true,
},
showRowLines: true,
showBorders: true,
columnAutoWidth: true,
wordWrapEnabled: true,
columns: [{
dataField: 'Task_Subject',
minWidth: 250,
validationRules: [{ type: 'required' }],
}, {
dataField: 'Task_Assigned_Employee_ID',
caption: 'Assigned',
minWidth: 120,
lookup: {
dataSource: DevExpress.data.AspNet.createStore({
key: 'ID',
loadUrl: `${url}/TaskEmployees`,
}),
valueExpr: 'ID',
displayExpr: 'Name',
},
validationRules: [{ type: 'required' }],
}, {
dataField: 'Task_Status',
caption: 'Status',
minWidth: 120,
lookup: {
dataSource: [
'Not Started',
'Need Assistance',
'In Progress',
'Deferred',
'Completed',
],
},
}, {
dataField: 'Task_Start_Date',
caption: 'Start Date',
dataType: 'date',
}, {
dataField: 'Task_Due_Date',
caption: 'Due Date',
dataType: 'date',
},
],
onInitNewRow(e) {
e.data.Task_Status = 'Not Started';
e.data.Task_Start_Date = new Date();
e.data.Task_Due_Date = new Date();
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.5/js/dx.all.js"></script>
<script src="https://unpkg.com/devextreme-aspnet-data@2.9.2/js/dx.aspnet.data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="tree-list"></div>
</div>
</body>
</html>
#tree-list {
max-height: 640px;
}
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Models;
using DevExtreme.MVC.Demos.Models.TreeList;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
[Route("api/TreeListTasks/{action}", Name = "TreeListTasks")]
public class TreeListTasksController : ApiController {
InMemoryTasksDataContext db = new InMemoryTasksDataContext();
[HttpGet]
public HttpResponseMessage Tasks(DataSourceLoadOptions loadOptions) {
var tasks = from d in db.Tasks
select new Models.TreeList.EmployeeTask {
Task_ID = d.Task_ID,
Task_Parent_ID = d.Task_Parent_ID,
Task_Owner_ID = d.Task_Owner_ID,
Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID,
Task_Completion = d.Task_Completion,
Task_Priority = d.Task_Priority,
Task_Status = d.Task_Status,
Task_Subject = d.Task_Subject,
Task_Start_Date = d.Task_Start_Date,
Task_Due_Date = d.Task_Due_Date,
Has_Items = db.Tasks.Count(task => task.Task_Parent_ID == d.Task_ID) > 0
};
return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions));
}
[HttpGet]
public HttpResponseMessage TasksWithEmployees(DataSourceLoadOptions loadOptions) {
var tasks = from d in db.Tasks
select new Models.TreeList.EmployeeTask {
Task_ID = d.Task_ID,
Task_Parent_ID = d.Task_Parent_ID,
Task_Owner_ID = d.Task_Owner_ID,
Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID,
Task_Assigned_Employee = db.TaskEmployees.Where(employee => employee.ID == d.Task_Assigned_Employee_ID).FirstOrDefault(),
Task_Completion = d.Task_Completion,
Task_Priority = d.Task_Priority,
Task_Status = d.Task_Status,
Task_Subject = d.Task_Subject,
Task_Start_Date = d.Task_Start_Date,
Task_Due_Date = d.Task_Due_Date
};
return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions));
}
[HttpGet]
public HttpResponseMessage TaskEmployees(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(db.TaskEmployees, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertTask(FormDataCollection form) {
var values = form.Get("values");
var newItem = new Models.TreeList.EmployeeTask();
JsonConvert.PopulateObject(values, newItem);
Validate(newItem);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
db.Tasks.Add(newItem);
db.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created);
}
[HttpPut]
public HttpResponseMessage UpdateTask(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var employee = db.Tasks.First(e => e.Task_ID == key);
JsonConvert.PopulateObject(values, employee);
Validate(employee);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
db.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK);
}
[HttpDelete]
public void DeleteTask(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var employee = db.Tasks.First(e => e.Task_ID == key);
db.Tasks.Remove(employee);
db.SaveChanges();
}
}
}
using System;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Models.TreeList {
public class InMemoryTasksDataContext : InMemoryDataContext<EmployeeTask> {
public ICollection<EmployeeTask> Tasks => ItemsInternal;
public IEnumerable<TaskEmployee> TaskEmployees => SampleData.SampleData.TaskEmployees;
protected override IEnumerable<EmployeeTask> Source => SampleData.SampleData.EmployeeTasks;
protected override int GetKey(EmployeeTask item) => item.Task_ID;
protected override void SetKey(EmployeeTask item, int key) => item.Task_ID = key;
}
}
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.ComponentModel.DataAnnotations;
namespace DevExtreme.MVC.Demos.Models.TreeList {
[JsonConverter(typeof(StringEnumConverter))]
public enum Priority { Low, Normal, High, Urgent }
public class EmployeeTask {
public int Task_ID { set; get; }
public int Task_Parent_ID { set; get; }
[Required]
[Display(Name = "Assigned")]
public int Task_Assigned_Employee_ID { set; get; }
public TaskEmployee Task_Assigned_Employee { set; get; }
public int Task_Owner_ID { set; get; }
[Required]
[Display(Name = "Task Subject")]
public string Task_Subject { set; get; }
[Display(Name = "Start Date")]
public DateTime Task_Start_Date { set; get; }
[Display(Name = "Due Date")]
public DateTime Task_Due_Date { set; get; }
[Display(Name = "Status")]
public string Task_Status { set; get; }
public Priority Task_Priority { set; get; }
public int Task_Completion { set; get; }
public bool Has_Items { get; set; }
}
public class TaskEmployee {
public int ID { set; get; }
public string Name { set; get; }
public string Picture { set; get; }
}
}

<dx-tree-list
id="tree-list"
[dataSource]="tasksData"
keyExpr="Task_ID"
parentIdExpr="Task_Parent_ID"
hasItemsExpr="Has_Items"
[expandedRowKeys]="[1, 2]"
[showRowLines]="true"
[showBorders]="true"
[columnAutoWidth]="true"
[wordWrapEnabled]="true"
(onInitNewRow)="initNewRow($event)"
>
<dxo-remote-operations
[filtering]="true"
[sorting]="true"
[grouping]="true"
></dxo-remote-operations>
<dxo-search-panel [visible]="true"></dxo-search-panel>
<dxo-header-filter [visible]="true"></dxo-header-filter>
<dxo-editing
mode="row"
[allowAdding]="true"
[allowUpdating]="true"
[allowDeleting]="true"
>
</dxo-editing>
<dxi-column dataField="Task_Subject" [minWidth]="250">
<dxi-validation-rule type="required"></dxi-validation-rule>
</dxi-column>
<dxi-column
dataField="Task_Assigned_Employee_ID"
caption="Assigned"
[minWidth]="120"
>
<dxo-lookup
[dataSource]="employeesData"
valueExpr="ID"
displayExpr="Name"
></dxo-lookup>
<dxi-validation-rule type="required"></dxi-validation-rule>
</dxi-column>
<dxi-column dataField="Task_Status" caption="Status" [minWidth]="120">
<dxo-lookup [dataSource]="statusesData"></dxo-lookup>
</dxi-column>
<dxi-column
dataField="Task_Start_Date"
caption="Start Date"
dataType="date"
></dxi-column>
<dxi-column
dataField="Task_Due_Date"
caption="Due Date"
dataType="date"
></dxi-column>
</dx-tree-list>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxTreeListModule } from 'devextreme-angular';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
tasksData: any;
employeesData: any;
statusesData: Array<string>;
constructor() {
const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks';
this.tasksData = AspNetData.createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
insertUrl: `${url}/InsertTask`,
updateUrl: `${url}/UpdateTask`,
deleteUrl: `${url}/DeleteTask`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
this.employeesData = AspNetData.createStore({
key: 'ID',
loadUrl: `${url}/TaskEmployees`,
});
this.statusesData = [
'Not Started',
'Need Assistance',
'In Progress',
'Deferred',
'Completed',
];
}
initNewRow(e) {
e.data.Task_Status = 'Not Started';
e.data.Task_Start_Date = new Date();
e.data.Task_Due_Date = new Date();
}
}
@NgModule({
imports: [
BrowserModule,
DxTreeListModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #tree-list {
max-height: 640px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@2.8.6/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37',
'devextreme-angular': 'npm:devextreme-angular@22.2.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.3/*/package.json',
'npm:devextreme-angular@22.2.3/ui/*/package.json',
'npm:devextreme-angular@22.2.3/package.json',
'npm:devexpress-diagram@2.1.65/package.json',
'npm:devexpress-gantt@4.1.37/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Models;
using DevExtreme.MVC.Demos.Models.TreeList;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
[Route("api/TreeListTasks/{action}", Name = "TreeListTasks")]
public class TreeListTasksController : ApiController {
InMemoryTasksDataContext db = new InMemoryTasksDataContext();
[HttpGet]
public HttpResponseMessage Tasks(DataSourceLoadOptions loadOptions) {
var tasks = from d in db.Tasks
select new Models.TreeList.EmployeeTask {
Task_ID = d.Task_ID,
Task_Parent_ID = d.Task_Parent_ID,
Task_Owner_ID = d.Task_Owner_ID,
Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID,
Task_Completion = d.Task_Completion,
Task_Priority = d.Task_Priority,
Task_Status = d.Task_Status,
Task_Subject = d.Task_Subject,
Task_Start_Date = d.Task_Start_Date,
Task_Due_Date = d.Task_Due_Date,
Has_Items = db.Tasks.Count(task => task.Task_Parent_ID == d.Task_ID) > 0
};
return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions));
}
[HttpGet]
public HttpResponseMessage TasksWithEmployees(DataSourceLoadOptions loadOptions) {
var tasks = from d in db.Tasks
select new Models.TreeList.EmployeeTask {
Task_ID = d.Task_ID,
Task_Parent_ID = d.Task_Parent_ID,
Task_Owner_ID = d.Task_Owner_ID,
Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID,
Task_Assigned_Employee = db.TaskEmployees.Where(employee => employee.ID == d.Task_Assigned_Employee_ID).FirstOrDefault(),
Task_Completion = d.Task_Completion,
Task_Priority = d.Task_Priority,
Task_Status = d.Task_Status,
Task_Subject = d.Task_Subject,
Task_Start_Date = d.Task_Start_Date,
Task_Due_Date = d.Task_Due_Date
};
return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions));
}
[HttpGet]
public HttpResponseMessage TaskEmployees(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(db.TaskEmployees, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertTask(FormDataCollection form) {
var values = form.Get("values");
var newItem = new Models.TreeList.EmployeeTask();
JsonConvert.PopulateObject(values, newItem);
Validate(newItem);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
db.Tasks.Add(newItem);
db.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created);
}
[HttpPut]
public HttpResponseMessage UpdateTask(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var employee = db.Tasks.First(e => e.Task_ID == key);
JsonConvert.PopulateObject(values, employee);
Validate(employee);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
db.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK);
}
[HttpDelete]
public void DeleteTask(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var employee = db.Tasks.First(e => e.Task_ID == key);
db.Tasks.Remove(employee);
db.SaveChanges();
}
}
}
using System;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Models.TreeList {
public class InMemoryTasksDataContext : InMemoryDataContext<EmployeeTask> {
public ICollection<EmployeeTask> Tasks => ItemsInternal;
public IEnumerable<TaskEmployee> TaskEmployees => SampleData.SampleData.TaskEmployees;
protected override IEnumerable<EmployeeTask> Source => SampleData.SampleData.EmployeeTasks;
protected override int GetKey(EmployeeTask item) => item.Task_ID;
protected override void SetKey(EmployeeTask item, int key) => item.Task_ID = key;
}
}
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.ComponentModel.DataAnnotations;
namespace DevExtreme.MVC.Demos.Models.TreeList {
[JsonConverter(typeof(StringEnumConverter))]
public enum Priority { Low, Normal, High, Urgent }
public class EmployeeTask {
public int Task_ID { set; get; }
public int Task_Parent_ID { set; get; }
[Required]
[Display(Name = "Assigned")]
public int Task_Assigned_Employee_ID { set; get; }
public TaskEmployee Task_Assigned_Employee { set; get; }
public int Task_Owner_ID { set; get; }
[Required]
[Display(Name = "Task Subject")]
public string Task_Subject { set; get; }
[Display(Name = "Start Date")]
public DateTime Task_Start_Date { set; get; }
[Display(Name = "Due Date")]
public DateTime Task_Due_Date { set; get; }
[Display(Name = "Status")]
public string Task_Status { set; get; }
public Priority Task_Priority { set; get; }
public int Task_Completion { set; get; }
public bool Has_Items { get; set; }
}
public class TaskEmployee {
public int ID { set; get; }
public string Name { set; get; }
public string Picture { set; get; }
}
}

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Web API Service

To access a Web API service from the client, use the createStore method from the DevExtreme.AspNet.Data extension. This extension also allows you to process data for DevExtreme components on the server. The server-side implementation is available under the TreeListTasksController.cs tab in the ASP.NET MVC and ASP.NET Core versions of this demo.

To notify the TreeList that data is processed on the server, set the remoteOperations property to true.

A 1-Click Solution for CRUD Web API Services with Role-based Access Control via EF Core

If you target .NET for your backend API, be sure to check out Web API Service and register your free copy today. The Solution Wizard scaffolds an OData v4 Web API Service (.NET 6+) with integrated authorization & CRUD operations powered by EF Core ORM. You can use OAuth2, JWT or custom authentication strategies alongside tools like Postman or Swagger (OpenAPI) for API testing. The built-in Web API Service also filters out secured server data based on permissions granted to users. Advanced/enterprise functions include audit trail, endpoints to download reports, file attachments, check validation, obtain localized captions, etc.

To use the free Solution Wizard (which creates the Web API Service), run the Universal Component Installer from the DevExpress Download Manager and use our predefined template in Visual Studio 2022+.

Read Tutorial | View Examples: JavaScript (DevExtreme) & JavaScript (Svelte) | Watch Videos

Backend API
<template> <div> <DxTreeList id="tree-list" :data-source="tasksData" :expanded-row-keys="[1, 2]" :show-row-lines="true" :show-borders="true" :column-auto-width="true" :word-wrap-enabled="true" key-expr="Task_ID" parent-id-expr="Task_Parent_ID" has-items-expr="Has_Items" @initNewRow="initNewRow($event)" > <DxRemoteOperations :filtering="true" :sorting="true" :grouping="true" /> <DxSearchPanel :visible="true"/> <DxHeaderFilter :visible="true"/> <DxEditing :allow-adding="true" :allow-updating="true" :allow-deleting="true" mode="row" /> <DxColumn :min-width="250" data-field="Task_Subject" > <DxRequiredRule/> </DxColumn> <DxColumn :min-width="120" data-field="Task_Assigned_Employee_ID" caption="Assigned" > <DxLookup :data-source="employeesData" value-expr="ID" display-expr="Name" /> <DxRequiredRule/> </DxColumn> <DxColumn :min-width="120" data-field="Task_Status" caption="Status" > <DxLookup :data-source="statusesData"/> </DxColumn> <DxColumn data-field="Task_Start_Date" caption="Start Date" data-type="date" /> <DxColumn data-field="Task_Due_Date" caption="Due Date" data-type="date" /> </DxTreeList> </div> </template> <script setup lang="ts"> import { DxTreeList, DxRemoteOperations, DxColumn, DxSearchPanel, DxHeaderFilter, DxEditing, DxRequiredRule, DxLookup, DxTreeListTypes, } from 'devextreme-vue/tree-list'; import { createStore } from 'devextreme-aspnet-data-nojquery'; const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks'; const tasksData = createStore({ key: 'Task_ID', loadUrl: `${url}/Tasks`, insertUrl: `${url}/InsertTask`, updateUrl: `${url}/UpdateTask`, deleteUrl: `${url}/DeleteTask`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }); const employeesData = createStore({ key: 'ID', loadUrl: `${url}/TaskEmployees`, }); const statusesData = [ 'Not Started', 'Need Assistance', 'In Progress', 'Deferred', 'Completed', ]; function initNewRow({ data }: DxTreeListTypes.InitNewRowEvent) { data.Task_Status = 'Not Started'; data.Task_Start_Date = new Date(); data.Task_Due_Date = new Date(); } </script> <style scoped> #tree-list { max-height: 640px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-aspnet-data-nojquery': { 'esModule': true, }, }, paths: { 'root:': '../../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@3.0.0/index.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.5/cjs', 'devextreme-vue': 'npm:devextreme-vue@23.2.5/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.51/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.5/css/dx.light.css" /> <script src="https://unpkg.com/typescript@4.2.4/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.3.4/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>
using DevExtreme.AspNet.Data; using DevExtreme.AspNet.Mvc; using DevExtreme.MVC.Demos.Models; using DevExtreme.MVC.Demos.Models.TreeList; using Newtonsoft.Json; using System; using System.Collections.Generic; using System.Linq; using System.Net; using System.Net.Http; using System.Net.Http.Formatting; using System.Web.Http; namespace DevExtreme.MVC.Demos.Controllers.ApiControllers { [Route("api/TreeListTasks/{action}", Name = "TreeListTasks")] public class TreeListTasksController : ApiController { InMemoryTasksDataContext db = new InMemoryTasksDataContext(); [HttpGet] public HttpResponseMessage Tasks(DataSourceLoadOptions loadOptions) { var tasks = from d in db.Tasks select new Models.TreeList.EmployeeTask { Task_ID = d.Task_ID, Task_Parent_ID = d.Task_Parent_ID, Task_Owner_ID = d.Task_Owner_ID, Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID, Task_Completion = d.Task_Completion, Task_Priority = d.Task_Priority, Task_Status = d.Task_Status, Task_Subject = d.Task_Subject, Task_Start_Date = d.Task_Start_Date, Task_Due_Date = d.Task_Due_Date, Has_Items = db.Tasks.Count(task => task.Task_Parent_ID == d.Task_ID) > 0 }; return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions)); } [HttpGet] public HttpResponseMessage TasksWithEmployees(DataSourceLoadOptions loadOptions) { var tasks = from d in db.Tasks select new Models.TreeList.EmployeeTask { Task_ID = d.Task_ID, Task_Parent_ID = d.Task_Parent_ID, Task_Owner_ID = d.Task_Owner_ID, Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID, Task_Assigned_Employee = db.TaskEmployees.Where(employee => employee.ID == d.Task_Assigned_Employee_ID).FirstOrDefault(), Task_Completion = d.Task_Completion, Task_Priority = d.Task_Priority, Task_Status = d.Task_Status, Task_Subject = d.Task_Subject, Task_Start_Date = d.Task_Start_Date, Task_Due_Date = d.Task_Due_Date }; return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions)); } [HttpGet] public HttpResponseMessage TaskEmployees(DataSourceLoadOptions loadOptions) { return Request.CreateResponse(DataSourceLoader.Load(db.TaskEmployees, loadOptions)); } [HttpPost] public HttpResponseMessage InsertTask(FormDataCollection form) { var values = form.Get("values"); var newItem = new Models.TreeList.EmployeeTask(); JsonConvert.PopulateObject(values, newItem); Validate(newItem); if(!ModelState.IsValid) return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage()); db.Tasks.Add(newItem); db.SaveChanges(); return Request.CreateResponse(HttpStatusCode.Created); } [HttpPut] public HttpResponseMessage UpdateTask(FormDataCollection form) { var key = Convert.ToInt32(form.Get("key")); var values = form.Get("values"); var employee = db.Tasks.First(e => e.Task_ID == key); JsonConvert.PopulateObject(values, employee); Validate(employee); if(!ModelState.IsValid) return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage()); db.SaveChanges(); return Request.CreateResponse(HttpStatusCode.OK); } [HttpDelete] public void DeleteTask(FormDataCollection form) { var key = Convert.ToInt32(form.Get("key")); var employee = db.Tasks.First(e => e.Task_ID == key); db.Tasks.Remove(employee); db.SaveChanges(); } } }
using System; using System.Collections.Generic; namespace DevExtreme.MVC.Demos.Models.TreeList { public class InMemoryTasksDataContext : InMemoryDataContext<EmployeeTask> { public ICollection<EmployeeTask> Tasks => ItemsInternal; public IEnumerable<TaskEmployee> TaskEmployees => SampleData.SampleData.TaskEmployees; protected override IEnumerable<EmployeeTask> Source => SampleData.SampleData.EmployeeTasks; protected override int GetKey(EmployeeTask item) => item.Task_ID; protected override void SetKey(EmployeeTask item, int key) => item.Task_ID = key; } }
using Newtonsoft.Json; using Newtonsoft.Json.Converters; using System; using System.ComponentModel.DataAnnotations; namespace DevExtreme.MVC.Demos.Models.TreeList { [JsonConverter(typeof(StringEnumConverter))] public enum Priority { Low, Normal, High, Urgent } public class EmployeeTask { public int Task_ID { set; get; } public int Task_Parent_ID { set; get; } [Required] [Display(Name = "Assigned")] public int Task_Assigned_Employee_ID { set; get; } public TaskEmployee Task_Assigned_Employee { set; get; } public int Task_Owner_ID { set; get; } [Required] [Display(Name = "Task Subject")] public string Task_Subject { set; get; } [Display(Name = "Start Date")] public DateTime Task_Start_Date { set; get; } [Display(Name = "Due Date")] public DateTime Task_Due_Date { set; get; } [Display(Name = "Status")] public string Task_Status { set; get; } public Priority Task_Priority { set; get; } public int Task_Completion { set; get; } public bool Has_Items { get; set; } } public class TaskEmployee { public int ID { set; get; } public string Name { set; get; } public string Picture { set; get; } } }

import React from 'react';
import TreeList, {
RemoteOperations, Column, SearchPanel, HeaderFilter, Editing, RequiredRule, Lookup,
} from 'devextreme-react/tree-list';
import AspNetData from 'devextreme-aspnet-data-nojquery';
const url = 'https://js.devexpress.com/Demos/Mvc/api/TreeListTasks';
const tasksData = AspNetData.createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
insertUrl: `${url}/InsertTask`,
updateUrl: `${url}/UpdateTask`,
deleteUrl: `${url}/DeleteTask`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const employeesData = AspNetData.createStore({
key: 'ID',
loadUrl: `${url}/TaskEmployees`,
});
const statusesData = [
'Not Started',
'Need Assistance',
'In Progress',
'Deferred',
'Completed',
];
const expandedKeys = [1, 2];
class App extends React.Component {
render() {
return (
<TreeList
id="tree-list"
dataSource={tasksData}
keyExpr="Task_ID"
parentIdExpr="Task_Parent_ID"
hasItemsExpr="Has_Items"
defaultExpandedRowKeys={expandedKeys}
showRowLines={true}
showBorders={true}
columnAutoWidth={true}
wordWrapEnabled={true}
onInitNewRow={initNewRow}>
<RemoteOperations filtering={true} sorting={true} grouping={true} />
<SearchPanel visible={true} />
<HeaderFilter visible={true} />
<Editing
mode="row"
allowAdding={true}
allowUpdating={true}
allowDeleting={true} />
<Column dataField="Task_Subject" minWidth={250}>
<RequiredRule />
</Column>
<Column dataField="Task_Assigned_Employee_ID" caption="Assigned" minWidth={120}>
<Lookup dataSource={employeesData} valueExpr="ID" displayExpr="Name" />
<RequiredRule />
</Column>
<Column dataField="Task_Status" caption="Status" minWidth={120}>
<Lookup dataSource={statusesData} />
</Column>
<Column dataField="Task_Start_Date" caption="Start Date" dataType="date" />
<Column dataField="Task_Due_Date" caption="Due Date" dataType="date" />
</TreeList>
);
}
}
function initNewRow(e) {
e.data.Task_Status = 'Not Started';
e.data.Task_Start_Date = new Date();
e.data.Task_Due_Date = new Date();
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#tree-list {
max-height: 640px;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@2.8.6/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using DevExtreme.MVC.Demos.Models;
using DevExtreme.MVC.Demos.Models.TreeList;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
namespace DevExtreme.MVC.Demos.Controllers.ApiControllers {
[Route("api/TreeListTasks/{action}", Name = "TreeListTasks")]
public class TreeListTasksController : ApiController {
InMemoryTasksDataContext db = new InMemoryTasksDataContext();
[HttpGet]
public HttpResponseMessage Tasks(DataSourceLoadOptions loadOptions) {
var tasks = from d in db.Tasks
select new Models.TreeList.EmployeeTask {
Task_ID = d.Task_ID,
Task_Parent_ID = d.Task_Parent_ID,
Task_Owner_ID = d.Task_Owner_ID,
Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID,
Task_Completion = d.Task_Completion,
Task_Priority = d.Task_Priority,
Task_Status = d.Task_Status,
Task_Subject = d.Task_Subject,
Task_Start_Date = d.Task_Start_Date,
Task_Due_Date = d.Task_Due_Date,
Has_Items = db.Tasks.Count(task => task.Task_Parent_ID == d.Task_ID) > 0
};
return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions));
}
[HttpGet]
public HttpResponseMessage TasksWithEmployees(DataSourceLoadOptions loadOptions) {
var tasks = from d in db.Tasks
select new Models.TreeList.EmployeeTask {
Task_ID = d.Task_ID,
Task_Parent_ID = d.Task_Parent_ID,
Task_Owner_ID = d.Task_Owner_ID,
Task_Assigned_Employee_ID = d.Task_Assigned_Employee_ID,
Task_Assigned_Employee = db.TaskEmployees.Where(employee => employee.ID == d.Task_Assigned_Employee_ID).FirstOrDefault(),
Task_Completion = d.Task_Completion,
Task_Priority = d.Task_Priority,
Task_Status = d.Task_Status,
Task_Subject = d.Task_Subject,
Task_Start_Date = d.Task_Start_Date,
Task_Due_Date = d.Task_Due_Date
};
return Request.CreateResponse(DataSourceLoader.Load(tasks, loadOptions));
}
[HttpGet]
public HttpResponseMessage TaskEmployees(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(db.TaskEmployees, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertTask(FormDataCollection form) {
var values = form.Get("values");
var newItem = new Models.TreeList.EmployeeTask();
JsonConvert.PopulateObject(values, newItem);
Validate(newItem);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
db.Tasks.Add(newItem);
db.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created);
}
[HttpPut]
public HttpResponseMessage UpdateTask(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var employee = db.Tasks.First(e => e.Task_ID == key);
JsonConvert.PopulateObject(values, employee);
Validate(employee);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
db.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK);
}
[HttpDelete]
public void DeleteTask(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var employee = db.Tasks.First(e => e.Task_ID == key);
db.Tasks.Remove(employee);
db.SaveChanges();
}
}
}
using System;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Models.TreeList {
public class InMemoryTasksDataContext : InMemoryDataContext<EmployeeTask> {
public ICollection<EmployeeTask> Tasks => ItemsInternal;
public IEnumerable<TaskEmployee> TaskEmployees => SampleData.SampleData.TaskEmployees;
protected override IEnumerable<EmployeeTask> Source => SampleData.SampleData.EmployeeTasks;
protected override int GetKey(EmployeeTask item) => item.Task_ID;
protected override void SetKey(EmployeeTask item, int key) => item.Task_ID = key;
}
}
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.ComponentModel.DataAnnotations;
namespace DevExtreme.MVC.Demos.Models.TreeList {
[JsonConverter(typeof(StringEnumConverter))]
public enum Priority { Low, Normal, High, Urgent }
public class EmployeeTask {
public int Task_ID { set; get; }
public int Task_Parent_ID { set; get; }
[Required]
[Display(Name = "Assigned")]
public int Task_Assigned_Employee_ID { set; get; }
public TaskEmployee Task_Assigned_Employee { set; get; }
public int Task_Owner_ID { set; get; }
[Required]
[Display(Name = "Task Subject")]
public string Task_Subject { set; get; }
[Display(Name = "Start Date")]
public DateTime Task_Start_Date { set; get; }
[Display(Name = "Due Date")]
public DateTime Task_Due_Date { set; get; }
[Display(Name = "Status")]
public string Task_Status { set; get; }
public Priority Task_Priority { set; get; }
public int Task_Completion { set; get; }
public bool Has_Items { get; set; }
}
public class TaskEmployee {
public int ID { set; get; }
public string Name { set; get; }
public string Picture { set; get; }
}
}